var mid_evttm=0;
var ppqntime=100;
var mid_ctime=0;
var mid_totaltime=0;
var midiFile = {};
var mid_abort=false;
var packet=new Array();

var TIMESCALE=1000; // 1000 = 1:1


function error(str) {
//	alert("Error: " + str);
	return str;
}
function upload_abort(){
	mid_abort=true;
	//document.getElementById("btn_abort").style.display = "none";
}

function mid_upload(nam){
	var xhr = new XMLHttpRequest();
	xhr.open('GET', './'+nam,true);
	xhr.responseType='arraybuffer';
	/*
	oReq.onload = function (oEvent) {
	  var arrayBuffer = oReq.response; // Note: not oReq.responseText
	  if (arrayBuffer) {
		var byteArray = new Uint8Array(arrayBuffer);
		for (var i = 0; i < byteArray.byteLength; i++) {
		  // do something with each byte in the array
		}
	  }
	};
	*/
	xhr.onreadystatechange = function() {
		if(xhr.readyState === 4 && xhr.status === 200) {
			var uInt8Array = new Uint8Array(this.response);
			var i = uInt8Array.length;
			var binaryString = new Array(i);
			while (i--)
			{
				//console.log(":"+String.fromCharCode(uInt8Array[i]));
			  //binaryString[i] = String.fromCharCode(uInt8Array[i]);
			}
			//var data = binaryString.join('');
			//console.log(data);
		  	decodeSMF(this.response);
		}
	}
	xhr.send();
}
function appendText( e, text ) {
	e.appendChild( document.createTextNode( text ) );
}
function readChunk(trk,evt){
	if(packet.length>0) sendOut(packet);	
	var again=false;
	console.log(evt);
	if(trk<midiFile.numTracks){
		again=true;
		var track = midiFile.tracks[trk];
		var str="";
		if(evt<track.events.length){
			again=true;
			var ev = track.events[evt];
			console.log("evt:"+evt+" / "+ev.delta);
			mid_evttm=(ev.delta*ppqntime);
			mid_ctime+=ev.delta;
			//console.log("entry @ "+tm+" / "+ev.type);
			//document.getElementById('status').innerHTML=ev.type;
			if (ev.type == "sysex") {
				// send chunk over
//				console.log(trk+":"+evt+":"+ev.metaData);
				//var chunk=ev.metaData.slice(2);
				//chunk.unshift(0xF0);
				ev.metaData.splice(1, 1);
				packet=ev.metaData;
//				document.getElementById('status').innerHTML="[sysex: " + ev.metaData + " ]"
			}
			if (ev.type == "MIDI") {
				var n = (ev.midiEventType << 4) + ev.midiChannel;
				str += "[" + n.toString(16) + " " + ev.parameter1.toString(16);
				if (ev.hasOwnProperty( "parameter2" ) )
					str += " " + ev.parameter2.toString(16);
				str += "] ";
			} else if (ev.type == "meta") {
				str += "[meta " + ev.metaType.toString(16) + " " + ev.metaData.length + "bytes]";
			} else {	// must be sysex
				str += "[sysex: " + ev.metaData.length + "bytes]";
			}
		
			document.getElementById('progress').style.width = Math.round(100*((mid_ctime*ppqntime)/mid_totaltime))+"%";
			evt++;
		}else{
			trk++;
		}
	}
	if(mid_abort){ // sent by button
		again=false;
	}
	if(again){
		setTimeout(function(){ readChunk(trk,evt) },TIMESCALE*mid_evttm);
	}else{
		// done
		if (mid_abort==true){
			mid_abort=false;
			document.getElementById('statustxt').innerHTML = 'Upload aborted';
		}else {
			document.getElementById('statustxt').innerHTML="Update Done";
			document.getElementById('progress').style.width ="0%";
			//document.getElementById("btn_abort").style.display = "none";
		}
	}
}
function mid_uploadMIDI() {
	for (i = 0; i<midiFile.numTracks; i++) {
		var track = midiFile.tracks[i];
		for (j=0;j<track.events.length;j++) {
			var ev = track.events[j];
			mid_totaltime+=ev.delta;
		}
	}
	ppqntime=1/(((midiFile.ticksPerBeat)/60)*96);
	mid_totaltime=mid_totaltime*ppqntime;
	console.log("file is "+mid_totaltime*1+" seconds");
	mid_abort=false;
	mid_ctime=0;
	//document.getElementById("btn_abort").style.display = "inline";
	document.getElementById('statustxt').innerHTML='Uploading Firmware';
	setTimeout(function(){ readChunk(0,0) },100);
}
function dumpFileInfo( e ) {	// Performs a simple dump of the MIDI file
	var i, j;

	if (!e)
		return;
	
	e.innerHTML = "File type: " + midiFile.format + "<br>" + 
		"Number of tracks: " + midiFile.numTracks + "<br>" + 
		"Ticks per beat: " + midiFile.ticksPerBeat + "<br>";
		
	for (i = 0; i<midiFile.numTracks; i++) {
		var track = midiFile.tracks[i];
		appendText( e, "Track #" + i + ": ")
		if (track.trackName)
			appendText( e, "\"" + track.trackName + "\" ");
		appendText( e, track.events.length + " events" );
		e.appendChild( document.createElement( "br" ) );

		var str="";
		var tm=0;
		for (j=0;j<track.events.length;j++) {
			var ev = track.events[j];

			str += "(" + ev.delta + ")";
			tm+=ev.delta;
			console.log("entry @ "+tm+" / "+ev.type);
			if (ev.type == "MIDI") {
				var n = (ev.midiEventType << 4) + ev.midiChannel;
				str += "[" + n.toString(16) + " " + ev.parameter1.toString(16);
				if (ev.hasOwnProperty( "parameter2" ) )
					str += " " + ev.parameter2.toString(16);
				str += "] ";
			} else if (ev.type == "meta") {
				str += "[meta " + ev.metaType.toString(16) + " " + ev.metaData.length + "bytes]";
			} else {	// must be sysex
				str += "[sysex: " + ev.metaData.length + "bytes]";
			}
			
		}
		appendText(e, str);
		e.appendChild( document.createElement( "br" ) );
		e.appendChild( document.createElement( "br" ) );
	}

}

function decodeVariableLengthValue(data, trackOffset ) {
	var i;
	var idx = trackOffset;
	var result = 0;
	
	do   {
		i = data.getUint8(idx++);
		result = result << 7;		// left-shift by 7 bits
		result += (i & 0x7f);	// mask off the top bit
	} while (i>=0x80);
	
	return {idx:idx,result:result};
}

function decodeMetaEvent( data, trackOffset, track, trackEvent ) {
	var idx = trackOffset + 1;  // we already know the first byte is 0xff
	var result;
	var length;
	var end;
	var metaData = [];
	
	trackEvent.type = "meta";
	
	trackEvent.metaType = data.getUint8(idx++);
/*	Type	Event	Type	Event
	0x00	 Sequence number	 
	0x01	 Text event	 
	0x02	 Copyright notice	 
	0x03	 Sequence or track name	 
	0x04	 Instrument name	 
	0x05	 Lyric text	 
	0x06	 Marker text	 
	0x07	 Cue point
	0x20	 MIDI channel prefix assignment
	0x2F	 End of track
	0x51	 Tempo setting
	0x54	 SMPTE offset
	0x58	 Time signature
	0x59	 Key signature
	0x7F	 Sequencer specific event */

	result = decodeVariableLengthValue( data, idx );
	idx = result.idx;
	length = result.result;
	end = idx + length;

	while (idx < end) {
		metaData.push(data.getUint8(idx++));
	}
	
	trackEvent.metaData = metaData;
	
	if (trackEvent.metaType == 0x03) {
		var str = "";
		var i;
		for (i=0; i<metaData.length; i++)
		   str += String.fromCharCode( metaData[i]);
		track.trackName = str;
	}

	return idx;
}

function decodeSysexEvent( data, trackOffset, track, trackEvent ) {
	var idx = trackOffset;
	var metaData = [];
	var d;

	trackEvent.type = "sysex";
	metaData.push(data.getUint8(idx++));
	
	// AJH: read & skip varlen:
	var varlen = 0;
	do
	{
		d = data.getUint8(idx++);
		varlen = (varlen<<7) | (d & 0x7f);
	} while ((d & 0x80) != 0);

	do {
		d = data.getUint8(idx++);
		metaData.push(d);
	} while (d!=0xf7);

	trackEvent.metaData = metaData;
	return idx;
}

function decodeMIDIEvent( data, idx, trackEvent ) {
	var eventType = data.getUint8(idx++);
	
	trackEvent.type = "MIDI";

	trackEvent.midiEventType = (eventType & 0xf0)>>4;
	trackEvent.midiChannel = eventType & 0x0f;
	
	trackEvent.parameter1 = data.getUint8(idx++);
	
	// program change and channel aftertouch don't have a param2
	if ((trackEvent.midiEventType != 0x0c)&&(trackEvent.midiEventType != 0x0d))
		trackEvent.parameter2 = data.getUint8(idx++);

	return (idx);
}

function decodeRunningModeMIDIEvent( data, idx, trackEvent, lastEvent ) {
	trackEvent.type = "MIDI";
	trackEvent.midiEventType = lastEvent.midiEventType;
	trackEvent.midiChannel = lastEvent.midiChannel;
	
	trackEvent.parameter1 = data.getUint8(idx++);
	
	// program change and channel aftertouch don't have a param2
	if ((trackEvent.midiEventType != 0x0c)&&(trackEvent.midiEventType != 0x0d))
		trackEvent.parameter2 = data.getUint8(idx++);

	return (idx);
}

function decodeTrackEvent( data, track, trackOffset ) {
	var eventLength; // in bytes
	var time;		// time this event occurs (delta)
	var trackEvent = {};
	var result;
	var idx = trackOffset;
	var lastEventIdx = track.events.length;

	result = decodeVariableLengthValue( data, idx );
	idx = result.idx;
	trackEvent.delta = result.result;

	// figure out what type of event we have - DON'T increment the index!!
	var i = data.getUint8(idx);
	if (i==0xff)
	  idx = decodeMetaEvent( data, idx, track, trackEvent );
	else if ((i==0xf0)||(i==0xf7))
	  idx = decodeSysexEvent( data, idx, track, trackEvent );
	else if (i & 0x80) // non-running-mode MIDI Event
	  idx = decodeMIDIEvent( data, idx, trackEvent );
	else if (lastEventIdx > 0)
	  idx = decodeRunningModeMIDIEvent( data, idx, trackEvent, track.events[track.events.length-1] );
	else {error("Running mode event with no previous event!"); return -1;}

	track.events.push(trackEvent);

	return idx;
}

function decodeTrack( data, track, trackOffset ) {
	var idx = trackOffset;
	var length;
	var end;
	
	//   char           ID[4];  // Track header "MTrk" 
	if ( (data.getUint8(idx++) != 0x4d) ||
	 	 (data.getUint8(idx++) != 0x54) ||
	 	 (data.getUint8(idx++) != 0x72) ||
	 	 (data.getUint8(idx++) != 0x6b) )
	  {error("This is not a System file"); return -1;}
			
	//   unsigned long length;  // length of track chunk in bytes
	track.byteLength = data.getUint32(idx);
	idx+=4;
	end = idx + track.byteLength;

	track.events = [];	// creates an empty array
	
	// any number of trackEvents.
	while (idx < end) {
		idx = decodeTrackEvent( data, track, idx );
		if (idx == -1)
			{error("error decoding track event"); return -1;}
	}
	
//	{error("error"); return -1;}
	return idx;
}
function decodeSMF( buffer ) {
	var data = new DataView(buffer);
	var idx=0;
	midiFile = {}; // clear the midi file object if it's already allocated
	
//	document.getElementById("updates").innerHTML = "";
//  alert( "File is " + buffer.byteLength + " bytes long.");

//   char           ID[4];  // File header "MThd" 
	if ( (data.getUint8(idx++) != 0x4d) ||
	 	 (data.getUint8(idx++) != 0x54) ||
	 	 (data.getUint8(idx++) != 0x68) ||
	 	 (data.getUint8(idx++) != 0x64) )
	  return(error("This is not a System file"));
		
//   unsigned long  Length; /* This should be 6 */
	if (data.getUint32(idx) != 6)
	  return(error("file header length is not 6."));
	idx+=4;

//   unsigned short format;
	midiFile.format = data.getUint16(idx);
	idx+=2;
	
	if ((midiFile.format < 0) || (midiFile.format > 2) )
		return(error("MIDI file format " + midiFile.format + " unrecognized."));
	
		if (midiFile.format == 2 )
			return(error("MIDI file format type 2 not supported."));

//   unsigned short numTracks;
	midiFile.numTracks = data.getUint16(idx);
	idx+=2;

//   unsigned short ticksPerBeat;
	midiFile.ticksPerBeat = data.getUint16(idx);
	idx+=2;

	midiFile.tracks=new Array(midiFile.numTracks);
	for (iTrack=0; iTrack<midiFile.numTracks; iTrack++) {
		midiFile.tracks[iTrack] = {};
		idx = decodeTrack( data, midiFile.tracks[iTrack], idx);
		if (idx == -1)
	  		return(error("error reading track #" + iTrack));
	}
//	mid_uploadMIDI();
//	alert("Success!");
	//dumpFileInfo( document.getElementById("updates") );
	
	return 0;
}
